;cpeek.dll -- debugging tool for Win32 console app's

comment| sample build file:
@echo off
\masm32\bin\ml /c /coff cpeek.asm
if errorlevel 1 goto end
echo LIBRARY cpeek>temp.def
echo EXPORTS info>>temp.def
echo EXPORTS regs>>temp.def
echo EXPORTS mem>>temp.def
\masm32\bin\polink /SUBSYSTEM:CONSOLE /STACK:4096 /HEAP:0,0 /DLL /DEF:temp.def cpeek.obj
del temp.def
del cpeek.exp
del cpeek.obj
dir cpeek.dll
:end
|

.686
.model flat, stdcall
option casemap:none
public info
public regs
public mem

include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib

cr equ 0Dh
lf equ 0Ah
crlf equ 0A0Dh

.data
info dd 3
     dd info,regs,mem
hStdOut dd 0
hStdIn dd 0

RegOutputLine_ equ 3+1+8+1+10+2  ; "REG hexhexhe decimaldec",cr,lf
RegOutputLine db RegOutputLine_ dup(0)

FlagOutputLine db "  F  ",cr,lf  ; e.g. " CF 1"
   FlagOutputLine_ = 7

MemHeader$ db "Memory from "
   MemDumpSite db 8 dup (0),cr,lf
MemHeader_ = 22

Prompt$ db "Resume or Quit? "
Prompt_ = 16

.code
Start:
    xor  eax,eax
    inc  eax
    ret  0Ch

GetStdOut:
    mov  eax,hStdOut
    or   eax,eax
    jnz  short @F
    invoke GetStdHandle,-11   ; -11 = STD_OUTPUT_HANDLE
    mov  hStdOut,eax
@@: ret

GetStdIn:
    mov  eax,hStdIn
    test eax,eax
    jnz  short @F
    invoke GetStdHandle,-10   ; -10 = STD_INPUT_HANDLE
    mov  hStdIn,eax
@@: ret

regs:
    pushad
    pushfd
    cld
    mov  ebx,esp
    lea  eax,[ebx+28h] ;caller's esp before "call regs" pushed a return address
    push eax
    push " PSE"
    push [ebx+0Ch]
    push " PBE"
    push [ebx+4]
    push " IDE"
    push [ebx+8]
    push " ISE"
    push [ebx+18h]
    push " XDE"
    push [ebx+1Ch]
    push " XCE"
    push [ebx+14h]
    push " XBE"
    push [ebx+20h]
    push " XAE"
    mov  esi,8         ;8 registers to show
@@: call RegRoutine
    dec  esi
    jnz  @B
    push 11    ;stack up the locations and names of seven flag bits
    push "O"
    push 10
    push "D"
    push 7
    push "S"
    push 6
    push "Z"
    push 4
    push "A"
    push 2
    push "P"
    push esi     ;0
    push "C"
    add  esi,7      ;cheaper than mov esi,7
    mov  edi,[ebx]  ;caller's flags
@@: pop  ecx
    mov  FlagOutputLine[1],cl
    pop  ecx
    bt   edi,ecx
    sbb  eax,eax
    neg  eax
    add  al,"0"
    mov  FlagOutputLine[4],al
    call GetStdOut
    push edx        ;make space on the stack to dump the amount written
    mov  edx,esp     ;point at it
    invoke WriteConsole,eax,addr FlagOutputLine,FlagOutputLine_,edx,0
    pop  edx
    dec  esi
    jnz  short @B
    call GetQorR
    popfd
    popad
    ret

RegRoutine:  ;register name, value
    pop  edx       ;return address
    pop  eax       ;register name
    mov  edi,offset RegOutputLine
    stosd
    pop  eax       ;register contents
    push edx      ;put back the return address
    call WriteEaxHex     ;augments edi, saves eax
    xchg eax,ecx
    mov  eax,"    "
    stosd
    stosd
    stosw
    xchg eax,ecx
    mov  word ptr[edi+1],crlf
    call WriteEaxDecimal
    call GetStdOut
    push edx
    mov  edx,esp
    invoke WriteConsole,eax,addr RegOutputLine,RegOutputLine_,edx,0
    pop  edx
    ret

mem:
    pushad
    pushfd
    cld
    push ebp
    mov  ebp,esp
  mem_base equ dword ptr[ebp+2Ch]
  mem_amt equ dword ptr[ebp+30h]
    mov  eax,mem_amt
    mov  ecx,160h
    test eax,eax
    cmovz eax,ecx
    cmp  eax,ecx
    cmova eax,ecx
    mov  mem_amt,eax  ;gets decremented
    mov  eax,mem_base
    mov  edi,offset MemDumpSite
    call WriteEaxHex
    call GetStdOut
    push edx
    mov  edx,esp
    invoke WriteConsole,eax,addr MemHeader$,MemHeader_,edx,0
    sub  esp,1472  ;22*(48+1+16+2), minus 4 for "push edx", rounded up to 4n
    mov  edi,esp
    mov  esi,mem_base
mem_outerloop:     ;writes one line of output
    push 10h
    pop  ebx       ;a counter
    push 0Ch
    pop  ecx
    mov  eax,"    "  ;write 49 spaces -- the hex part of one line of output
    push edi
    rep  stosd
    stosb
    mov  ecx,edi     ;point ecx at the ascii part of the output line
    pop  edi
mem_innerloop:
    lodsb            ;get a byte from memory
    mov  dl,"."
    cmp  al," "
    cmovnb edx,eax
    mov  [ecx],dl     ;poke the ascii character
    inc  ecx
    call al2hexax
    stosw            ;poke the two-byte hex dump of the same character
    inc  edi          ;bypass one space
    dec  mem_amt
    jz   short @F
    dec  ebx
    jnz  mem_innerloop
    mov  word ptr[ecx],crlf
    add  edi,13h      ;bypass one space, 16 ascii chars, and CRLF
    jmp  mem_outerloop
@@: mov  edi,ecx
    mov  ax,crlf
    stosw
    call GetStdOut
    mov  ecx,esp
    sub  edi,ecx
    push edx
    mov  edx,esp
    invoke WriteConsole,eax,ecx,edi,edx,0
    call GetQorR
    leave
    popfd
    popad
    ret 8

GetQorR:
    push edx
    mov  edx,esp
    invoke WriteConsole,hStdOut,addr Prompt$,Prompt_,edx,0
    pop  edx
    call GetStdIn
    invoke FlushConsoleInputBuffer,eax
GetQorR_1:
    push edx     ;make a 4-byte read buffer
    mov  eax,esp  ;point eax at it
    push edx
    mov  edx,esp
    invoke ReadConsole,hStdIn,eax,1,edx,0
    pop  edx
    pop  eax
    or   al,20h   ;convert to lower case
    cmp  al,"r"
    je   short AnyRet
    cmp  al,"q"
    jne  short GetQorR_1
    invoke FlushConsoleInputBuffer,hStdIn
    invoke ExitProcess,0

al2hexax:
    mov  ah,al
    shr  ah,4
    call @F
    xchg al,ah
@@: and  al,0Fh
    cmp  al,0Ah
    sbb  al,69h
    das
AnyRet:
    ret

WriteEaxDecimal:    ;edi points at the destination of the last digit
    mov ecx,10
@@: xor edx,edx
    div ecx
    or  dl,"0"
    mov [edi],dl
    dec edi
    or  eax,eax
    jnz short @B
    ret

WriteEaxHex:
    mov  ecx,4
@@: rol  eax,8
    push eax
    call al2hexax
    stosw
    pop  eax
    loop @B
    ret

end Start
